/*
             CREATOR: DAn williams
                DATE:
         DESCRIPTION:
            FILENAME:    .c
             STARTED:
    OPERATING SYSTEM: Linux
1st VERSION FINISHED:
*/


#include <stdio.h>
#include <string.h>
//#include <conio.h>  // for dos
#include <stdlib.h>
#include "portman.c"
#include "cmnCmdOptions.c"

//global functions
void testPort   ( void ) ;
void setupParams( void ) ;
int  SetHelpFlag( char* unused ) ;
int  SetPort    ( char* port )   ;
int  SetAuto    ( char* unused ) ;
int  SetQuiet   ( char* unused ) ;
int  SetLoud    ( char* unused ) ;
int  SetHellow  ( char* unused ) ;
int  UserHelp   ( void ) ;


//global variables
  int retcode;
  int help;      // 1 = just give help and exit.
  int ScanMode;  // 0 = check one port, 1 = scan all three ports
  int Port;      // the port to scan if scanmode = 1
  int verbose;   // -1 = quiet, 0=normal, 1 = talkative
  int helloWorld; // 1= just say hello world and go byebye.
  
  

int main(int argc, char** argv)
{
  // local variables
  int portHandle;
 
  retcode    = 0;
  help       = 0;
  ScanMode   = 0;
  Port       = 0;
  verbose    = 0;
  helloWorld = 0;
  
  setupParams();
  parseOptions(argc, argv);
  
  if (verbose >  (-1)) {
    printf(" This program pings a parallel port to confirm existance. \n");
    printf("  	WARNING, USING THIS PROGRAM WITH THE WRONG PORT NUMBER WOULD BE BAD\n");
    printf(" Written by Dan Williams Sep 20 2001 \n");
  }
  
  if (argc < 2) {                          // do we have input paramiters??   
      printf("Need input paramiters, use %s --help \n", argv[0]);
      return 0;    
  }
  
  if (help) {
    UserHelp();
	 if (verbose > (0)) {
	   printf ("Contact me at: dan_williams@sunshine.net");
	 }
	 return 1;
  }
  
  if (helloWorld) {
    printf("Hello, world!\n");
	 return 1;
  }
  
  if ((ScanMode == 0) & (Port == 0)) {
    printf("Problem with specified port number, it evaluated to Zero.\n");
	 return 0;
  }
  
  if (ScanMode == 0) { // scan one port
   if (Port == 0) {
	  printf(" Today is doomsday.\n");
	}
    
   testPort();
  
  } else { // scan multiple ports
  
   Port = 632;
	testPort();
	Port = 888;
	testPort();
	Port = 956;
	testPort();
  
  }
  
  return(retcode);
}


//subroutines

void testPort( void ) {
  
   int portHandle;
  
   if (verbose > 0) {
     printf("Opening port %d\n", Port);
   }
  
   if (( portHandle = portCommander_Open(Port)) == NULL) {
     if (verbose > (-1)) {
 	   printf("Failed to Open port, are you root?\n");
 		return;
     }
   }
  
   if (verbose > 0) {
      printf("Sending 0xFF\n");
   }
  
   portCommander_Write(portHandle, 0xff, 0xff);
  
   if (portCommander_Read(portHandle) == 0xff) {
	   if (verbose > 0) {
         printf("Sending 0x00\n");
      }
  
      portCommander_Write(portHandle, 0x00, 0xff);
  
      if (portCommander_Read(portHandle) == 0x00) {
	     if (verbose > 0) {
            printf("Sending 0x55\n");
        }
  
        portCommander_Write(portHandle, 0x55, 0xff);
  
        if (portCommander_Read(portHandle) == 0x55) {
		      if (verbose > (-1)) {
		       printf("Success!! a parallel port is there!\n");
				}
				
				printf("Confirmation of address %d\n", Port);
				
   	  } else {
		    if (verbose > (-1)) {
	   	   printf("Ping Failed, nothing there\n");
			}
		  }		  
      } else {
		  if (verbose > (-1)) {
		    printf("Ping Failed, nothing there\n");
		  }
		}
	 } else {
       if (verbose > (-1)) {
	     printf("Ping Failed, nothing there\n");
		 }
	 }

  return;
}


void setupParams(void) {

    // this is outright ugly, but we have to because of limits to C :-|
  static char* optsHelp[3] = {"-h", "--help", "?"};
  static char* optsPort[2] = {"-p", "--port"};
  static char* optsAuto[2] = {"-a", "--autoscan"};
  static char* optsMore[2] = {"-v", "--verbose"};
  static char* optsLess[2] = {"-s", "--shutTheHeckupAlready"};
  static char* optsHelo[1] = {"--HelloWorld"};
  
  cmdLineOptionInit();
  
  addCmdLineOption(optsHelp, 3, SetHelpFlag);
  addCmdLineOption(optsPort, 2, SetPort);
  addCmdLineOption(optsAuto, 2, SetAuto);
  addCmdLineOption(optsLess, 2, SetQuiet);
  addCmdLineOption(optsMore, 2, SetLoud);
  addCmdLineOption(optsHelo, 1, SetHellow);
  
}


int SetHelpFlag( char * unused ) {
   help       = 1;  
	helloWorld = 0;
   return 0;
}

int SetPort( char* port ) {
   Port       = atoi(port);
	ScanMode   = 0;
	helloWorld = 0;
	help       = 0;  
   return 1;
}

int SetAuto (char * unused ) {
   ScanMode   = 1;
	helloWorld = 0;
   help       = 0;  
	return 0;
}

int SetQuiet (char * unused) {
   help    = 0;  
   verbose = (-1);
	return 0;
}

int SetLoud (char * unused) {
   help    = 0;  
   verbose = 1;
	return 0;
}

int SetHellow (char * unused) {
  help       = 0;
  helloWorld = 1;
  return 0;
}




int UserHelp() {

 printf(" Parallel port Pinger. by DAn williams \n\n");
 printf("   Options are as follows:\n\n");
 printf("      -h, --help, ?   Display this help \n");
 printf("      -p, --port      The address of the presumed port (in decimal) \n");
 printf("      -a, --autoscan  Automatically scan for ports 1,2,3 (dangerous) \n");
 printf("      -v, --verbose   Talk a little more than usual.\n");
 printf("      -s, --shutTheHeckupAlready Talk a little less than usual\n");
 printf("      --HelloWorld    Print \"Hello World\" and exit\n\n");
 printf("   Addresses of standard parallel ports are: \n");
 printf("     LPT1: 632 \n");
 printf("     LPT2: 888 \n");
 printf("     LPT3: 956 \n");
 printf("   To make the program so something, either specify a port address, \n");
 printf("     or use the autoscan option. The autoscan works by sending data to \n");
 printf("     the standard addresses for LPT 1, 2, and 3, which may offend other \n");
 printf("     devices on those ports. (e.g network cards) This data is not seen as\n");
 printf("     relivent to any printers on those ports.\n");
 printf("     The later pramiters win arguments.\n\n");
 printf("   Example of use:\n");
 printf("     pingpar --port 632 \n\n");
 printf("  And remember, serious things arn't fun. :-P \n");   

 return 0;
}


